<?php
	
	header("Access-Control-Allow-Origin: *");
	header("Content-Type: application/json; charset=UTF-8");
	header("Access-Control-Allow-Methods: POST");
	header("Access-Control-Max-Age: 3600");
	header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

	require_once '../../../../init.php';
      
	// Required files
	require_once MAX_PATH . '/lib/OA/Dal.php';      
	require_once MAX_PATH . '/lib/OA/Admin/Option.php';
	require_once MAX_PATH . '/lib/OA/Admin/Settings.php';      
	require_once MAX_PATH . '/www/admin/config.php';
	require_once MAX_PATH . '/lib/max/Plugin/Translation.php';
    
    OA_Permission::enforceAccount(OA_ACCOUNT_MANAGER, OA_ACCOUNT_TRAFFICKER, OA_ACCOUNT_ADMIN);

    ##DB
	 if($GLOBALS['_MAX']['CONF']['database']['type']=='pgsql'){
		require_once MAX_PATH . '/lib/OA/Dal/Delivery/pgsql.php';
	}else if($GLOBALS['_MAX']['CONF']['database']['type']=='mysqli'){
		require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysqli.php';
	}

   	$data = array(); 
   	$labels = array();
   	$request =array();
	$impressions = array();
	$clicks = array();
	$conversions = array();
	$views = array();
	$ecpm = array();
	$vecpm = array();
	$ctr = array();
	$total_revenue = array();
	
	## INITIALISATIN
   	$condition = '';
   	$getQuery = '';
   	$limit = "";
   	$id = "";
   	$groupby = "";
   	$data_type = " cl.clientname AS data_type ";

   	## REQUIRED POST VALIES
   	$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
   	$start_date = $_POST['start_date'];
   	$end_date = $_POST['end_date'];
   	$line_dimension = $_POST['line_dimension'];

   	//~ACCOUNT 
    if(isset($_POST['id']) && !empty($_POST['id'])) {
      $id = explode('=', $_POST['id']);
    }

    if(isset($id[0]) && $id[0] == 'clientid'){
      $condition = 'AND cl.clientid='.$id[1];
    }elseif(isset($id[0]) && $id[0] == 'pubid'){
      $condition = 'AND a.affiliateid='.$id[1];
    }elseif(isset($id[0]) && $id[0] == 'manager'){
      $condition = 'AND cl.agencyid='.$id[1];
    }
	$agencyid = OA_Permission::getAgencyId();
	## LINE DIMENSION
	if(!$line_dimension[0]) {

		$groupby = " GROUP BY cl.clientname ";

	}else{
		
		$groupby = " GROUP BY ";
		$data_type = "";
		$length  = sizeof($line_dimension);
		$i = 0;

		foreach ($line_dimension as $key) {

			if($key == 1){

				$groupby .= "c.campaignid ";
				$data_type .= " c.campaignname AS data_type";

			}else if($key == 2){

				$groupby .= "b.bannerid ";
				$data_type .= " b.description AS data_type";

			}else if($key == 3){

				$groupby .= "p.id ";
				$data_type .= " p.name AS data_type";

			}else if($key == 4){

				$groupby .= "a.affiliateid ";
				$data_type .= " a.name AS data_type";

			}else if($key == 5){

				$groupby .= "z.zonename ";
				$data_type .= " z.zonename AS data_type";

			}else if($key == 6){

				$groupby .= "DATE(adh.date_time) ";
				$data_type .= " DATE(adh.date_time) AS data_type";

			}else if($key == 7){

				$groupby .= "sco.country ";
				$data_type .= " sco.country AS data_type";

			}$i++;
			if($i < $length){
				$groupby .= ',';
				$data_type .= ',';
			}

		}
	}
	if (OA_Permission::isAccount(OA_ACCOUNT_ADMIN)) {
	$getQuery = " SELECT {$data_type}, SUM(adh.requests) as requests, SUM(adh.impressions) AS impressions, SUM(adh.clicks) AS clicks, SUM(adh.conversions) as conversions FROM {$table_prefix}clients cl LEFT JOIN {$table_prefix}campaigns c ON c.clientid = cl.clientid LEFT JOIN {$table_prefix}banners b ON b.campaignid = c.campaignid LEFT JOIN {$table_prefix}data_summary_ad_hourly adh ON adh.ad_id = b.bannerid {$extra_join} LEFT JOIN {$table_prefix}zones z ON z.zoneid = adh.zone_id LEFT JOIN {$table_prefix}affiliates a ON a.affiliateid = z.affiliateid WHERE adh.ad_id > 0 AND DATE(adh.date_time) >= '".$start_date."' AND DATE(adh.date_time) <= '". $end_date."' ".$condition." ".$groupby. $_POST['limit'];
	}
	else
	{
		$getQuery = " SELECT {$data_type}, SUM(adh.requests) as requests, SUM(adh.impressions) AS impressions, SUM(adh.clicks) AS clicks, SUM(adh.conversions) as conversions FROM {$table_prefix}clients cl LEFT JOIN {$table_prefix}campaigns c ON c.clientid = cl.clientid LEFT JOIN {$table_prefix}banners b ON b.campaignid = c.campaignid LEFT JOIN {$table_prefix}data_summary_ad_hourly adh ON adh.ad_id = b.bannerid {$extra_join} LEFT JOIN {$table_prefix}zones z ON z.zoneid = adh.zone_id LEFT JOIN {$table_prefix}affiliates a ON a.affiliateid = z.affiliateid LEFT JOIN 
        {$table_prefix}agency ag  ON ag.agencyid = a.agencyid WHERE adh.ad_id > 0 AND DATE(adh.date_time) >= '".$start_date."' AND DATE(adh.date_time) <= '". $end_date."' AND ag.agencyid ={$agencyid} ".$condition." ".$groupby. $_POST['limit'];
	}
	$data = array();
	$getQuery = OA_Dal_Delivery_Query($getQuery);
	
	while ($aRow = OA_Dal_Delivery_fetchAssoc($getQuery)) 
	{
		$labels[] = (strlen($aRow['data_type']) > 5 ? substr($aRow['data_type'],0,10)."..." : $aRow['data_type']);
		$requests[] = $aRow['requests'];
		$impressions[] = $aRow['impressions'];
		$clicks[] = $aRow['clicks'];
		$conversions[] = $aRow['conversions'];
		$total_revenue[] = $aRow['total_revenue'];

        $ctr[] = ($aRow['impressions'] > 0)? round($aRow['clicks']/$aRow['impressions']*100, 2) : 0.00;
    }

    $data = array('labels' => $labels,'requests'=>$requests,'impressions' => $impressions, 'clicks' => $clicks, 'conversions'=>$conversions, 'ctr'=>$ctr);

   	echo json_encode($data);
	exit();
    
		
